stages:
  - package
  - scan
  - integration
  - tag

push image docker:
  image: docker:stable
  stage: package
  services:
    - docker:18-dind
  script:
    - docker build -t $CI_REGISTRY_IMAGE:latest -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA .
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker push $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA

scanning:
  image: alpine:3.13
  stage: scan
  script:
    - apk add -u curl
    - curl -sfL https://raw.githubusercontent.com/aquasecurity/trivy/master/contrib/install.sh | sh -s -- -b /usr/local/bin
    - trivy image $CI_REGISTRY_IMAGE:latest > cve.txt
  artifacts:
    paths: [cve.txt]

integration test:
  image: docker:stable
  stage: integration
  services:
    - docker:18-dind
  script:
    - docker run -d --name myapp $CI_REGISTRY_IMAGE:latest
    - sleep 10s
    - TEST_RESULT=$(docker run --link myapp lucj/curl -s http://myapp:8000)
    - echo $TEST_RESULT
    - $([ "$TEST_RESULT" == "Hello!" ])

update_manifest:
  stage: tag
  image: alpine:3.13
  variables:
    USER: dakli.david
    PROJECT: demo-api
    REGISTRY: registry.gitlab.com
    GIT_REPOSITORY: git@gitlab.com:$USER/$PROJECT.git
  before_script:
    - apk add --no-cache git
    - git remote set-url origin https://$USER:${CI_PUSH_TOKEN}@gitlab.com/$USER/$PROJECT.git
    - git config --global user.email "gitlab@gitlab.com"
    - git config --global user.name "GitLab CI/CD"
    - git checkout -B main
  script:
    - cd manifests
    - sed -i "s/image:\ $REGISTRY.*/image:\ $REGISTRY\/$USER\/$PROJECT:$CI_COMMIT_SHORT_SHA/" deploy.yaml
    - git commit -am '[skip ci] update image tag'
    - git push origin main
  only:
    - master
    - main
